/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
/* SCCS ID: @(#)scan_defs.h	1.8 10/13/93 */
/*************************************************************************
 * FILE:      scan_defs.h
 * Author:    Claude Saunders
 * Purpose:   Defines device definition data structures.
 *
 * Mods:      login mm/dd/yy: description
 *************************************************************************/

#include "devconsts.h"

#define MAXNAMECHAR 80

typedef struct msg {
  char name[MAXNAMECHAR];
  int dir;               /* READ or WRITE */
  int nargs;             /* 0 or 1 */
  int type;              /* DBR_DOUBLE or DBR_STRING */
  char def[MAXNAMECHAR];
  struct msg *next;
} MSG, *PMSG;

typedef struct class {
  char name[MAXNAMECHAR];
  struct msg *msgh;
  struct class *next;
} CLASS, *PCLASS;

typedef struct pvmsg {
  char pvname[MAXNAMECHAR];
  PMSG msgh;
  struct pvmsg *next;
} PVMSG, *PPVMSG;

typedef struct dev {
  char name[MAXNAMECHAR];
  int type;                 /* COMPOSITE or ATOMIC */
  char class[MAXNAMECHAR];
  PPVMSG pvmsgh;
  struct dev *next;
} DEV, *PDEV;

PCLASS allocateClass();
PCLASS findClass(char *classname);
PDEV allocateDev(PDEV pdev);
PDEV dev_find(char *devname);
PDEV dev_add(char *devname);
void dev_delete(char *devname);
PDEV dev_next(int op);
void freeDev(void *userPvt);
void freeCDev(void *userPvt);
PPVMSG allocatePVMsg(PDEV pdev);
PMSG allocateMsg(PCLASS pclass);
PMSG findMsg(PCLASS pclass,char *msgname);
int scan_defs();
