/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
/* SCCS ID: @(#)scandefs.c	1.2 10/6/93 */

#include <sys/param.h>
#include <unistd.h>
#include <netdb.h>
#include <stdio.h>
#include <rpc/rpc.h>
#include <strings.h>
#include <stdlib.h>
#include "dev.h"

int main(argc,argv)
int argc;
char *argv[];
{

  CLIENT *cl;
  char server[MAXHOSTNAMELEN];
  char **res;
  
  if (argc != 2) {
    fprintf(stderr,"usage: %s path\n",argv[0]);
    exit(1);
  }
  gethostname(server,MAXHOSTNAMELEN);
  
  if ((cl = clnt_create(server,DEVICE_PROG,DEVICE_VERS,"tcp")) == NULL) {
    clnt_pcreateerror(server);
    exit(2);
  }
  
  if ((res = scan_composite_defs_1(&(argv[1]),cl)) == NULL) {
    clnt_perror(cl,server);
    exit(4);
  }
  if (strlen(*res) > 0)
    fprintf(stderr,"%s\n",*res);

  clnt_destroy(cl);
  return(0);
}

